<template>

  <div class="main-contain">
    <div class="position">
      <bread-crumb :crumbs='crumbs'></bread-crumb>
      <el-button size="small" @click="AddNewOrder" class="filter-item" style="float:right;" type="primary"
                 icon="el-icon-circle-plus-outline">新增
      </el-button>
    </div>

    <div class="app-container">


      <div class="cell clearfix" >
        <el-input size="small" style="width: 400px;" class="filter-item" v-model.trim="searchKey" placeholder="单据编码/制单人/厂商"/>
        <el-button size="small" class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">日期查询</span> : </label>
        <el-date-picker v-model="start_time" prefix-icon="el-icon-date" :editable="false" style="width: 196px;"
                        type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                        value-format="yyyy-MM-dd" @change="startTimeChange"></el-date-picker>
        <span class="cellLine"> - </span>
        <el-date-picker v-model="end_time" prefix-icon="el-icon-date" :editable="false" style="width: 196px;"
                        type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                        value-format="yyyy-MM-dd" @change="endTimeChange"></el-date-picker>
      </div>

      <div class="filter-container" style="margin-top: 10px">
        <el-checkbox style="width: 30px" v-model="checked" @change="changeAllSelected">全选</el-checkbox>
        <el-button size="small" icon="el-icon-delete" @click="batchDelete">删除</el-button>

      </div>

      <el-row :gutter="12" style="margin-top: 10px">
        <el-table
          :data="cancelStockDate"
          :class="signAndWeighBoxPatients"
          border
          highlight-current-row
          ref="multipleTable"
          @selection-change="select"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)'}"

        >



          <el-table-column label="单据编号" align="center">
            <template slot-scope="scope">
              {{scope.row.warehousing_order}}
            </template>
          </el-table-column>

          <el-table-column label="商品类型" align="center">
            <template slot-scope="scope">
              {{specificationName(scope.row.good_id)}}
            </template>
          </el-table-column>


          <el-table-column label="单据类型" align="center">
            <template slot-scope="scope">
              {{getTypeName(scope.row)}}
            </template>
          </el-table-column>

          <el-table-column label="操作时间" align="center">
            <template slot-scope="scope">
              {{ scope.row.warehousing_time | parseTime('{y}-{m}-{d}')}}
            </template>
          </el-table-column>
          <el-table-column label="制单人" align="center">
            <template slot-scope="scope">
              {{getXuserName(scope.row.creater)}}

            </template>
          </el-table-column>
          <el-table-column label="单价" align="center">
            <template slot-scope="scope">
              {{scope.row.price}}
            </template>
          </el-table-column>
          <el-table-column label="数量" align="center">
            <template slot-scope="scope">
              {{scope.row.warehousing_count}}
            </template>
          </el-table-column>
          <el-table-column label="总价" align="center">
            <template slot-scope="scope">
              {{scope.row.price *  scope.row.warehousing_count}}
            </template>
          </el-table-column>

        </el-table>

        <el-pagination
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :page-sizes="[7]"
          :page-size="7"
          background
          style="margin-top:20px;float: right"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total">
        </el-pagination>

      </el-row>
    </div>
  </div>
</template>

<script>
  import { uParseTime } from '@/utils/tools'
  import { fetchAllAdminUsers, fetchAllDoctorAndNurse } from '@/api/doctor'
  import { deleteCancelStock, GetAllConfig, getStockDetail } from '@/api/stock'
  import BreadCrumb from '../components/bread-crumb'

  export default {
    name: 'salesReturnOrder',
    components: { BreadCrumb },
    created() {
      var year = new Date().getFullYear()
      var month = new Date().getMonth() + 1
      var day = new Date().getDate()
      if (parseInt(month) < 10) {
        month = '0' + month
      }
      if (parseInt(day) < 10) {
        day = '0' + day
      }
      const endTime = year + '-' + month + '-' + day
      this.end_time = endTime

      var year = new Date().getFullYear()
      var month = new Date().getMonth()
      var day = new Date().getDate()
      if (parseInt(month) < 10) {
        month = '0' + month
      }
      if (parseInt(day) < 10) {
        day = '0' + day
      }
      const startTime = year + '-' + month + '-' + day
      this.start_time = startTime
      this.GetCancelStock()
      this.GetConfigInfo()
      this.fetchAllAdminUsers()
    },
    data() {
      return {
        crumbs: [
          { path: false, name: '库存管理' },
          { path: '/stock/detail', name: '出入库明细查询' }
        ],
        searchKey: '',
        type: 1,
        page: 1,
        limit: 7,
        checked: false,
        total: 0,
        pageTotal: 0,
        pageSelect: 0,
        adminUserOptions: [],
        multipleSelection: [],
        signAndWeighBoxPatients: 'sign-and-weigh-box-patients',
        start_time: '',
        cancelStockDate: [],
        end_time: '',
        goodType: [],
        goodInfo: [],
        manufacturer: [],
        selectedTableData: [],
        dealer: []

      }
    },
    methods: {
      getTypeName: function(row) {
        let name = ''
        let name2 = ''
        if (row.type == 1) {
          name = '耗材'
        } else if (row.type == 2) {
          name = '其他'
        }
        if (row.types == 1) {
          name2 = '入库单'
        } else if (row.types == 2) {
          name2 = '出库单'
        } else if (row.types == 3) {
          name2 = '退货单'
        } else if (row.types == 4) {
          name2 = '退库单'
        }
        return name + name2
      },
      specificationName: function(good_info_id) {
        let name = ''
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == good_info_id) {
            name = this.goodInfo[i].specification_name
          }
        }
        return name
      },
      search: function() {
        const Params = {
          page: this.page,
          limit: this.limit,
          start_time: this.start_time,
          end_time: this.end_time,
          type: this.type,
          keywords: this.searchKey
        }
        this.cancelStockDate = []
        getStockDetail(Params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.total = response.data.data.total
            for (let i = 0; i < response.data.data.list.length; i++) {
              this.cancelStockDate.push(response.data.data.list[i])
            }
          }
        })
      },
      AddNewOrder: function() {
        this.$router.push({ name: 'cancelStockOrderAdd', query: { type: this.type }})
      },
      GetCancelStock: function() {
        const Params = {
          page: this.page,
          limit: this.limit,
          start_time: this.start_time,
          end_time: this.end_time,
          type: this.type
        }
        this.cancelStockDate = []
        getStockDetail(Params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.total = response.data.data.total
            for (let i = 0; i < response.data.data.list.length; i++) {
              this.cancelStockDate.push(response.data.data.list[i])
            }
          }
        })
      }, getXuserName(id) {
        if (id <= 0) {
          return ''
        }
        var name = ''
        if (this.adminUserOptions == null || typeof (this.adminUserOptions.length) === 'undefined') {
          return name
        }
        var leng = this.adminUserOptions.length
        if (leng == 0) {
          return name
        }
        for (let index = 0; index < leng; index++) {
          if (this.adminUserOptions[index].id == id) {
            name = this.adminUserOptions[index].name
            break
          }
        }
        return name
      }, fetchAllAdminUsers() {
        fetchAllAdminUsers().then(response => {
          console.log(response)
          if (response.data.state == 1) {
            this.adminUserOptions = response.data.data.users
            var alen = this.adminUserOptions.length
            for (let index = 0; index < alen; index++) {
              if (this.adminUserOptions[index].user_type == 2) {
                // this.doctorOptions.push(this.adminUserOptions[index]);
              }
            }
          }
        })
      }, handleSelectionChange: function(val) {
        this.multipleSelection = val
      }, handleSizeChange(val) {
        this.limit = val
        this.GetWarehouse()
      }, handleCurrentChange(val) {
        this.page = val
        this.GetWarehouse()
      }, startTimeChange(val) {
        this.GetWarehouse()
      }, endTimeChange(val) {
        this.GetWarehouse()
      }, calculate: function(val) {
        return Math.round(parseFloat(val) * 100) / 100
      }, GetConfigInfo: function() {
        GetAllConfig().then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.manufacturer = response.data.data.manufacturer
            this.dealer = response.data.data.dealer
            this.goodInfo = response.data.data.goodInfo
          }
        })
      }, getManufactuerName: function(manufacturer_id) {
        for (let i = 0; i < this.manufacturer.length; i++) {
          if (this.manufacturer[i].id == manufacturer_id) {
            return this.manufacturer[i].manufacturer_name
          }
        }
      }, getDealerName: function(dealer_id) {
        for (let i = 0; i < this.dealer.length; i++) {
          if (this.dealer[i].id == dealer_id) {
            return this.dealer[i].dealer_name
          }
        }
      }, handleEdit: function(index, row) {
        this.$router.push({ name: 'cancelStockDetail', query: { id: row.id, type: this.type }})
      }, handleDelete: function(index, row) {
        const ids = []
        ids.push(row.id)
        const idStr = ids.join(',')

        const params = {
          ids: idStr
        }

        this.$confirm('确认删除出库退库单记录?', '删除出库退库单记录', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          deleteCancelStock(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg)
              return false
            } else {
              this.$notify({
                title: '成功',
                message: '删除成功',
                type: 'success',
                duration: 2000
              })
              for (let i = 0; i < ids.length; i++) {
                for (let y = 0; y < this.cancelStockDate.length; y++) {
                  if (ids[i] == this.cancelStockDate[y].id) {
                    this.cancelStockDate.splice(y, 1)
                  }
                }
              }
            }
          })
        }).catch(() => {
        })
      }, changeAllSelected: function(val) {
        if (val) {
          this.$refs.multipleTable.toggleAllSelection()
        } else {
          this.$refs.multipleTable.clearSelection()
        }
      }, select(selection) {
        this.selectedTableData = selection
      }, batchDelete() {
        if (this.selectedTableData.length <= 0) {
          this.$message.error('请选择要删除的记录')
          return
        }
        const ids = []
        for (let i = 0; i < this.selectedTableData.length; i++) {
          ids.push(this.selectedTableData[i].id)
        }
        const idStr = ids.join(',')
        const params = {
          ids: idStr
        }
        this.$confirm('确认删除出库退库单记录?', '删除出库退库单记录', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          deleteCancelStock(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg)
              return false
            } else {
              this.$notify({
                title: '成功',
                message: '删除成功',
                type: 'success',
                duration: 2000
              })

              for (let i = 0; i < ids.length; i++) {
                for (let y = 0; y < this.cancelStockDate.length; y++) {
                  if (ids[i] == this.cancelStockDate[y].id) {
                    this.cancelStockDate.splice(y, 1)
                  }
                }
              }
            }
          })
        }).catch(() => {
        })
      }
    }
  }
</script>

<style rel="stylesheet/css" lang="scss" scoped>
  .information {
    border: 1px #dcdfe6 solid;
    padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }

  }


  .edit_separater {
    border-top: 1px solid rgb(233, 233, 233);
    margin-top: 15px;
    margin-bottom: 15px;
  }

</style>

<style>
  .sign-and-weigh-box .sign-and-weigh-box-patients .cell {
    font-size: 12px;
  }

  .sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
    background: #6fb5fa;
  }

  .count {
    color: #bd2c00;

  }

</style>
